
<?php

define("COORDINATE_TYPE",'c');

define("WORD_LOCATE",'locate');
define("WORD_IN",'in');
define("WORD_URL",'url');

define("SYNTHETICAL_WORD_EARTH_COORDINATES",'_coord_');


function is_locate(&$word_list,$mark_word=false)
{
	global $WORD;

	return word_name_checking($word_list,array(WORD_LOCATE),$mark_word);	
	//return word_name_checking($word_list,array(WORD_IS,WORD_BE,WORD_BEEN,WORD_BEING),$mark_word);
}



function add_location(&$sentence)
{
	$location_text = "";
	
	for ($c=0; $c < sizeof($sentence); $c++)
	{	
		if (is_locate($sentence[$c]['word']))
		{
			$location = $c;
			
			while (1)
			{
				$location = get_child($sentence,$location,L_TYPE,WORD_IN);
				
				if ($location != INVALID_POSITION)
					$location = get_child($sentence,$location,M_TYPE);
				else
					break;
				
				$location_text .= $sentence[$location]['raw_word'] . ", ";
			}

		
			if ($location_text != "")
			{
				$location_text = substr($location_text,0,-1);
				
		//		$address_id = enter_address($location_text);
				$coordinates = getLatLong($location_text);
				
				deby("<br/>LOCATION = $location_text || (" . $coordinates['latitude'] . "," . $coordinates['longitude'] . ")");
				
				$position_coordinates = add_word_to_sentence($sentence,SYNTHETICAL_WORD_EARTH_COORDINATES,true);
				
				$sentence[$position_coordinates]['l_value'] = get_child($sentence,$c,N_TYPE);
				
				$sentence[$position_coordinates]['l_type'] = COORDINATE_TYPE;

				$sentence[$position_coordinates]['coordinates'] = $coordinates;
			}
		}
	}
}

/*
function add_location(&$sentence)
{
	$index_word_in = get_index(WORD_IN,$PREPOSITIONS);
	
	
	for ($c=0; $c < sizeof($sentence); $c++)
		if (is_locate($sentence[$c]['word']))
		{
			while (1)
			{
				$location = get_child($sentence,$c,L_TYPE);
				
				if (isset($sentence[$location]['preposition'])  &&  $sentence[$location]['preposition'] == $index_word_in)
					$location_text .= $sentence[$location]['raw_word'] . ",";
				else
					return
			}
		}
}*/


function getLatLong($address)
{
// ------------------------------------------
// converts a string with a stret address
// into a couple of lat, long coordinates.
// ------------------------------------------
//    if (!is_string($address))die("All Addresses must be passed as a string");
    $_url = sprintf('http://maps.google.com/maps?output=js&q=%s',rawurlencode($address));
    $_result = false;
    if($_result = file_get_contents($_url)) {
        if(strpos($_result,'errortips') > 1 || strpos($_result,'Did you mean:') !== false) return false;
        preg_match('!center:\s*{lat:\s*(-?\d+\.\d+),lng:\s*(-?\d+\.\d+)}!U', $_result, $_match);
        $_coords['latitude'] = $_match[1];
        $_coords['longitude'] = $_match[2];
    }
    return $_coords;
}	


function rad($angle_in_degree)
{
	return $angle_in_degree*pi() /180;
}

function earth_distance_haversine($latitude1,$longitude1,$latitude2,$longitude2)
{
	$latitude1 = rad($latitude1);
	$longitude1 = rad($longitude1);
	$latitude2 = rad($latitude2);	
	$longitude2 = rad($longitude2);

	$distance = 6371 * acos ( sin($latitude1)*sin($latitude2)
			+ cos($latitude1)*cos($latitude2)*cos($longitude2-$longitude1) );
	
/*	$distance = 2 * 6371 * asin(sqrt(haversin($longitude2-$longitude1)			  // FLAWED !!! FEHLERHAFT !!!
			+ cos($longitude1)*cos($longitude2)*haversin($latitude2-$latitude1)   ));
*/	
	return $distance;
}

function extract_input_parameters(&$sentence)
{
	$url = extract_value_of_is_sentence($sentence,WORD_URL);

	return array($url);
}

function extract_value_of_is_sentence(&$sentence,$raw_word)
{
	for ($c=0; $c < sizeof($sentence); $c++)
		if ( is_be($sentence[$c]['word'])
			&&  (($subject = get_child($sentence,$c,S_TYPE,$raw_word)) != INVALID_POSITION)
			&&  (($object = get_child($sentence,$c,N_TYPE)) != INVALID_POSITION)
			)
		{
		
			if (get_child($sentence,$subject,L_TYPE) == INVALID_POSITION)
				return get_selected_word_id($sentence,$object);

		}
		
	return 0;
}



?>

